package com.tzld.piaoquan.recommend.server.service.rank.strategy;

import com.tzld.piaoquan.recommend.server.model.Video;
import com.tzld.piaoquan.recommend.server.service.rank.RankParam;
import com.tzld.piaoquan.recommend.server.service.rank.RankResult;
import com.tzld.piaoquan.recommend.server.service.rank.RankService;
import com.tzld.piaoquan.recommend.server.service.recall.strategy.VideoInsightRecallStrategy;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

@Service
@Slf4j
public class RankStrategy4Alpha extends RankService {

    public RankResult rank(RankParam param) {
        if (param == null
                || param.getRecallResult() == null
                || CollectionUtils.isEmpty(param.getRecallResult().getData())) {
            return null;
        }

        List<Video> results = new ArrayList<>(extractAndSort(param, VideoInsightRecallStrategy.PUSH_FORM));
        results = results.subList(0, Math.min(results.size(), param.getSize()));
        return new RankResult(results);

    }

    @Override
    public List<Video> mergeAndRankRovRecall(RankParam param) {
        return null;
    }

    @Override
    public RankResult mergeAndSort(RankParam param, List<Video> rovRecallRank, List<Video> flowPoolRank) {
        return null;
    }
}
